---
updatedAt: 2026-04-24T14:44:02.000Z
agentTools:
  projectIndex: https://docs.talkdesk.com/llms.txt
---

# create or update the Time off balance.

Import time off balance.

## Scope

`wfm-request-management-public:write`

# OpenAPI definition

```json
{
  "openapi": "3.0.2",
  "info": {
    "title": "Public API",
    "version": "5.12.66",
    "description": "Documents public API endpoints. Scopes are given to external software, that we don't control",
    "contact": {
      "name": "Talkdesk",
      "url": "https://talkdesk.com"
    }
  },
  "servers": [
    {
      "url": "https://api.talkdeskapp.com",
      "description": "United States (td-us-1)"
    },
    {
      "url": "https://api.talkdeskapp.eu",
      "description": "Europe (td-eu-1)"
    },
    {
      "url": "https://api.talkdeskappca.com",
      "description": "Canada (td-ca-1)"
    },
    {
      "url": "https://api.talkdeskapp.co.uk",
      "description": "United Kingdom (td-uk-1)"
    }
  ],
  "tags": [
    {
      "name": "WFM Request Management API",
      "description": "WFM Request Management API"
    }
  ],
  "paths": {
    "/wfm/request-management/externals/time-offs/balances": {
      "put": {
        "x-namespace": "/wfm/request-management",
        "description": "Import time off balance.",
        "operationId": "PutTimeOffBalanceExternal",
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "type": "object",
                "description": "The request body of time off balances",
                "properties": {
                  "time_off_balances": {
                    "type": "array",
                    "description": "The list of time off balance",
                    "items": {
                      "properties": {
                        "agent_email": {
                          "description": "The email of the user",
                          "type": "string",
                          "example": "mars.xiao@talkdesk.com"
                        },
                        "event_type_name": {
                          "description": "Defines part of the Time off type.",
                          "type": "string",
                          "example": "annual"
                        },
                        "balance": {
                          "description": "The balance of the time off type",
                          "type": "number",
                          "example": 1200,
                          "minimum": 1,
                          "maximum": 50000
                        }
                      }
                    },
                    "required": [
                      "agent_email",
                      "event_type_name"
                    ]
                  }
                },
                "required": [
                  "time_off_balances"
                ]
              },
              "example": {
                "time_off_balances": [
                  {
                    "agent_email": "mars.xiao@talkdesk.com",
                    "event_type_name": "annual",
                    "balance": 1200
                  },
                  {
                    "agent_email": "jeff.ke@talkdesk.com",
                    "event_type_name": "break",
                    "balance": 200
                  }
                ]
              }
            }
          },
          "description": "The time off balance",
          "required": true
        },
        "responses": {
          "200": {
            "description": "Time Off balance successfully updated",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "description": "The list of time off balance response",
                  "properties": {
                    "time_off_balances": {
                      "type": "array",
                      "description": "The time off balance",
                      "items": {
                        "type": "object",
                        "properties": {
                          "id": {
                            "description": "The ID of the time off balance",
                            "type": "string",
                            "maxLength": 36
                          },
                          "agent_email": {
                            "description": "The email of the user",
                            "type": "string"
                          },
                          "balance": {
                            "description": "The balance of the time off type",
                            "type": "number",
                            "minimum": 1,
                            "maximum": 50000
                          },
                          "event_type_name": {
                            "description": "Defines part of the Time off type.",
                            "type": "string"
                          }
                        }
                      },
                      "required": [
                        "balance",
                        "event_type_name"
                      ]
                    }
                  },
                  "required": [
                    "id",
                    "agent_email"
                  ]
                },
                "example": {
                  "time_off_balances": [
                    {
                      "id": "8858c834481d4a028176cffc02c50350",
                      "agent_email": "mars.xiao@talkdesk.com",
                      "event_type_name": "annual",
                      "balance": 1200
                    },
                    {
                      "id": "028176cffc034481d4ac5035028858c8",
                      "agent_email": "jeff.ke@talkdesk.com",
                      "event_type_name": "break",
                      "balance": 200
                    }
                  ]
                }
              }
            }
          },
          "400": {
            "content": {
              "application/json": {
                "example": {
                  "code": "1580001",
                  "message": "Invalid fields."
                },
                "schema": {
                  "type": "object",
                  "required": [
                    "code",
                    "message"
                  ],
                  "properties": {
                    "code": {
                      "type": "string"
                    },
                    "message": {
                      "type": "string"
                    },
                    "description": {
                      "type": "string"
                    },
                    "fields": {
                      "type": "array",
                      "items": {
                        "type": "object",
                        "required": [
                          "name",
                          "description"
                        ],
                        "properties": {
                          "name": {
                            "type": "string"
                          },
                          "description": {
                            "type": "string"
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            "description": "Validation errors were found in the submitted data."
          },
          "401": {
            "content": {
              "application/json": {
                "example": {
                  "code": "1580005",
                  "message": "Invalid authentication."
                },
                "schema": {
                  "type": "object",
                  "required": [
                    "code",
                    "message"
                  ],
                  "properties": {
                    "code": {
                      "type": "string"
                    },
                    "message": {
                      "type": "string"
                    },
                    "description": {
                      "type": "string"
                    },
                    "fields": {
                      "type": "array",
                      "items": {
                        "type": "object",
                        "required": [
                          "name",
                          "description"
                        ],
                        "properties": {
                          "name": {
                            "type": "string"
                          },
                          "description": {
                            "type": "string"
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            "description": "Unauthorized"
          },
          "403": {
            "content": {
              "application/json": {
                "example": {
                  "code": "1580006",
                  "message": "Invalid permissions."
                },
                "schema": {
                  "type": "object",
                  "required": [
                    "code",
                    "message"
                  ],
                  "properties": {
                    "code": {
                      "type": "string"
                    },
                    "message": {
                      "type": "string"
                    },
                    "description": {
                      "type": "string"
                    },
                    "fields": {
                      "type": "array",
                      "items": {
                        "type": "object",
                        "required": [
                          "name",
                          "description"
                        ],
                        "properties": {
                          "name": {
                            "type": "string"
                          },
                          "description": {
                            "type": "string"
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            "description": "Forbidden"
          },
          "404": {
            "content": {
              "application/json": {
                "example": {
                  "code": "1580007",
                  "message": "Resource not found."
                },
                "schema": {
                  "type": "object",
                  "required": [
                    "code",
                    "message"
                  ],
                  "properties": {
                    "code": {
                      "type": "string"
                    },
                    "message": {
                      "type": "string"
                    },
                    "description": {
                      "type": "string"
                    },
                    "fields": {
                      "type": "array",
                      "items": {
                        "type": "object",
                        "required": [
                          "name",
                          "description"
                        ],
                        "properties": {
                          "name": {
                            "type": "string"
                          },
                          "description": {
                            "type": "string"
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            "description": "Time Off Balance not found"
          }
        },
        "security": [
          {
            "GA": [
              "wfm-request-management-public:write"
            ]
          }
        ],
        "summary": "create or update the Time off balance.",
        "tags": [
          "WFM Request Management API"
        ]
      }
    }
  },
  "components": {
    "securitySchemes": {
      "GA": {
        "type": "oauth2",
        "flows": {
          "authorizationCode": {
            "authorizationUrl": "https://{account_name}.talkdeskid.com/oauth/authorize",
            "tokenUrl": "https://{account_name}.talkdeskid.com/oauth/token",
            "scopes": {
              "account:read": "Show account details",
              "apps:read": "Get details about app installations for an account",
              "apps:write": "Update an app installation state programatically",
              "attributes:read": "List attributes or attribute categories for an account and get details for a specific attribute",
              "attributes:write": "Create, update and remove attributes or attributes categories for an account",
              "bulk-imports:read": "Get list of imports and export errors into CSV file",
              "bulk-imports:write": "Create and update import data",
              "messages:write": "Ability to send messages from the API",
              "callback:write": "Request a new direct callback",
              "contacts-integrations:read": "Get details for contacts' integrations",
              "contacts:read": "Get details for contact(s)",
              "contacts:write": "Create, update or delete contacts",
              "contact-gdpr:write": "GDPR Contacts",
              "continuity-settings:read": "Read business continuity settings",
              "continuity-settings:write": "Change business continuity settings",
              "continuity-settings-activation:read": "Read information on activation of the continuity settings",
              "continuity-settings-activation:write": "Edit information on activation of the continuity settings",
              "data-reports:read": "Download previously generated data reports",
              "data-reports:write": "Create new data reports",
              "data-tables:read": "Fetch and list data tables",
              "data-tables:write": "Create and update data tables",
              "data-tables-exports:read": "List and download data table exports",
              "data-tables-exports:write": "Create and cancel data table exports",
              "events:read": "Get details from received events",
              "express-provisioning:read": "Express-provisioning validate if account exists",
              "express-provisioning:write": "Provisioning of an account",
              "express-accounts-usage:read": "Read usage information for an account",
              "express-accounts:read": "Read account information",
              "express-accounts-contracts:read": "Get contract info for express accounts",
              "express-accounts-contracts-actions:write": "Create contract actions for express accounts",
              "express-accounts-contracts-actions:read": "Read contract actions of express accounts",
              "express-products:read": "Read product information",
              "express-accounts-subscriptions:read": "Read subscription information for an account",
              "express-accounts-invoices:read": "Read invoice information for an account",
              "erc-ecommerce-shopify-webhooks-handler-credentials:write": "Create or update Shopify webhook handler credentials",
              "erc-ecommerce-shopify-webhooks-handler-credentials:read": "Read Shopify webhook handler credentials",
              "flows-interactions:start": "Starts an interaction associated with a flow",
              "flows-platform:submit": "Trigger an automation flow associated with an account",
              "fsi-accounts:read": "List of accounts associated with a contact",
              "fsi-contacts:write": "Update contact information",
              "fsi-contacts:read": "List and get contact details",
              "fsi-cards:read": "List of cards from a account",
              "fsi-cards:write": "Update the status for a card",
              "fsi-payments:read": "List of payments from a specific account",
              "fsi-transactions:read": "List of transactions for a specific account",
              "fsi-payoff:read": "Get the payoff for an FSI account",
              "fsi-transfers:write": "Create an FSI Transfer",
              "fsi-stop-payment:write": "Cancel a payment before it’s been processed",
              "fsi-travel-notification:write": "Create a new endpoint for Travel Notifications",
              "fsi-checks:read": "Search for a check",
              "fsi-set-ach-transfer:write": "FSI Set ACH Transfer",
              "fsi-unlock-account:write": "Unlock account for a banking customer",
              "fsi-decrypt:read": "The decryption based on AES algorithm",
              "fsi-write-back:write": "FSI Write Data Back",
              "fsi-spend-limit:read": "Daily limit for reading debit cards",
              "fsi-spend-limit:write": "Modify the daily limit of debit cards",
              "guardian-call-quality:read": "Read Guardian call quality data.",
              "guardian-sessions:read": "Read Sessions Guardian data.",
              "guardian-users:read": "Read Users Guardian data.",
              "guardian-cases:read": "Read Cases Guardian data.",
              "identity-activity:read": "Identity activity read access",
              "identity-email-validation:read": "Identity Email Validation read access",
              "identity-ip-validation:read": "Identity IP Validation read access",
              "identity-phone-validation:read": "Identity Phone Validation read access",
              "openid": "User info endpoint",
              "recordings:read": "Get recording files",
              "recordings:delete": "Delete recording files",
              "refresh_token": "Token refresh flow",
              "reports:read": "List previously generated reports and download them",
              "reports:write": "Create new reports or delete existing ones",
              "queues:read": "List CCAAS queues",
              "queues:write": "Create/update CCAAS queues details",
              "queues-users:read": "List users assigned to a CCAAS queue",
              "users:read": "List users for an account and get details for a specific user",
              "users:write": "Create, Update and Delete users",
              "interactions:control-recordings": "Control the recording status of an interaction",
              "fsi-workspace-contact-synchronization:write": "Synchronize Talkdesk contact with fsi member information",
              "voicebiometrics-enroll:write": "Update and delete Voice Biometrics enroll data",
              "voicebiometrics-consent:read": "VoiceBiometrics consent read access",
              "voicebiometrics-consent:write": "VoiceBiometrics consent write access",
              "live-queries:read": "Read and list queries from Live API",
              "live-subscriptions:read": "Read subscriptions from Live API",
              "live-subscriptions:write": "Create a new subscription for Live API",
              "wfm-aion-public:write": "Create, Update and Delete WFM Aion related data by an external client.",
              "wfm-request-management-public:write": "Create, Update and Delete WFM Request Management related data by an external client.",
              "wfm-request-management-public:read": "Read WFM Request Management related data by an external client.",
              "account-wallets:read": "Get information about account wallets",
              "bucket-configurations:read": "Get all bucket configurations",
              "cases-public:write": "Create,update and delete case data",
              "cases-public:read": "Read case",
              "case-notes-public:read": "Read case note data",
              "case-notes-public:write": "Create, edit, and delete case note data",
              "case-fields-public:read": "Read case field",
              "do-not-call-lists:manage": "Update a DNCL by adding or deleting a entry on a do not call list",
              "do-not-call-lists:read": "Read entries in a do not call list",
              "record-lists:manage": "Ability to view, add and update records of a Record List",
              "record-lists:write": "Create and update record lists for an account",
              "role-permissions:skip": "Skip role permissions validation",
              "campaigns:write": "Create, update and delete campaigns",
              "campaigns:read": "List and view available campaigns",
              "schedule-callbacks:read": "List schedule callbacks",
              "schedule-callbacks:write": "schedule a callbacks or reschedule a callbacks",
              "po-record-list-automations:write": "Custom record list automations for proactive outbound clients",
              "prompts:read": "Read prompts",
              "prompts:write": "Create a prompt",
              "prompts:delete": "Delete a prompt",
              "prompts:download": "Get prompt download link",
              "webhooks-trigger:write": "Create, update and delete a webhook trigger",
              "cfm-public:write": "Collect feedback data",
              "digital-connect:read": "List and Get digital-connect Resources",
              "digital-connect:write": "Create, Update and Delete digital-connect Resources",
              "entitymapper-contact-interactions:write": "Update interaction's contact mappings",
              "locations-directory:read": "Read locations information",
              "locations-directory:write": "Write/update locations information and custom fields",
              "locations-directory:support": "Create/Update/Delete locations-directory support features",
              "staffs-directory:read": "Read staffs information",
              "staffs-directory:write": "Write/update staffs information",
              "automated-notifications-management:read": "Read Automated Notifications related account information",
              "automated-notifications-management:write": "Write Automated Notifications related account information",
              "automated-notifications:read": "Read Automated Notifications event information",
              "automated-notifications:write": "Write Automated Notifications event information",
              "automated-notifications-bridge:write": "Write permissions for automated-notifications-bridge webhooks",
              "automated-notifications-subscriptions:read": "Read Automated Notifications subscriptions related to a topic/channel",
              "automated-notifications-subscriptions:write": "Write (subscribe/unsubscribe) Automated Notifications subscriptions related to a topic/channel",
              "entitymapper-map:write": "Write mappings with external entities",
              "entitymapper-contacts:read": "Search Talkdesk contact",
              "entitymapper-contacts:write": "Write Talkdesk contact",
              "appointment-scheduling-va:read": "Read appointment scheduling va entries",
              "hls-coverage:read": "Read healthcare & life sciences coverage information",
              "hls-balance:read": "Read healthcare & life sciences balance information",
              "hls-patient:read": "Read healthcare & life sciences patient information",
              "hls-providers:call-answered": "Write healthcare & life sciences call answered information",
              "hls-appointment:read": "Read healthcare & life sciences patient appointments",
              "hls-medication-order:read": "Read healthcare & life sciences patient medication orders",
              "hls-appointment:write": "Write healthcare & life sciences patient appointments",
              "hls-contact:write": "Write healthcare & life sciences data into talkdesk contact",
              "hls-provider:read": "Read healthcare & life sciences provider appointments",
              "hls-phone-action:write": "Write healthcare & life sciences phone action",
              "hls-click-to-call:write": "Write healthcare & life sciences click-to-call action",
              "hls-epic-outgoing-sms:write": "Trigger outgoing SMS from Epic",
              "hls-epic-agent-status-sync:write": "Trigger agent status sync from Epic",
              "hls-inbasket-message:write": "Send in-basket message to Epic",
              "hls-popup-intent:write": "Save intent of a patient",
              "hls-prescription:read": "Read healthcare & life sciences prescription information",
              "hls-prescription:write": "Write healthcare & life sciences prescription information",
              "hls-encounter:read": "Read healthcare & life sciences patient encounters",
              "hls-service-request:read": "Read healthcare & life sciences patient service requests",
              "hls-procedure:read": "Read healthcare & life sciences patient procedures",
              "hls-payers-connections:read": "Read healthcare & life sciences payers information",
              "hls-payers-connections:write": "Write healthcare & life sciences payers information",
              "hls-symptom-checker:write": "Symptom checker for patient",
              "hls-patient:write": "Write healthcare & life sciences patient information",
              "hls-epic:call-answered": "Write healthcare & life sciences call answered information",
              "hls-sycurio:integrate": "Integrate with Sycurio platform",
              "hls-patient-case:write": "Write healthcare & life sciences patient case information",
              "hls-outstanding-order:read": "Read healthcare & life sciences outstanding orders",
              "hls-medication-order:write": "Write healthcare & life sciences medication order(request)",
              "hls-medication-statement:write": "Write healthcare & life sciences medication statement",
              "hls-medication-statement:read": "Read healthcare & life sciences medication statement",
              "hls-hl7-events:write": "Write healthcare providers HL7 events",
              "erc-ecommerce-connections-orders:write": "Update e-commerce connections orders info",
              "erc-ecommerce-connections-customers:read": "Read e-commerce connections customers info",
              "erc-ecommerce-connections-customers:write": "Write e-commerce connections customers info",
              "erc-ecommerce-connections-orders:read": "Read e-commerce connections orders info",
              "erc-ecommerce-connections-products:read": "Read e-commerce connections products info",
              "erc-ecommerce-customers:read": "Read e-commerce customers info",
              "erc-ecommerce-customers:write": "Write e-commerce customers info",
              "erc-ecommerce-return-reasons:read": "Read e-commerce return reasons",
              "erc-ecommerce-return:read": "Read e-commerce return info",
              "erc-ecommerce-return:write": "Write e-commerce return info",
              "erc-ecommerce-cart:write": "Sync e-commerce cart items",
              "erc-ecommerce-products:read": "Search e-commerce catalog products",
              "erc-ecommerce-orders:read": "Show e-commerce integrations orders info",
              "erc-ecommerce-orders:write": "Update e-commerce integrations orders info",
              "erc-ecommerce-recall:write": "Write e-commerce recall contacts",
              "industries-settings-public:write": "Write industries settings",
              "industries-contexts:write": "Create, update, and delete context values",
              "fsi-insurance-connections-automated-notifications:write": "Write Automated Notifications event information",
              "fsi-insurance-connections-contacts:write": "Sync Talkdesk contacts",
              "fsi-insurance-connections-claims:read": "Read claims by id from FSI Insurance",
              "fsi-insurance-integrations-policies:read": "Read policies from FSI Insurance",
              "fsi-insurance-integrations-accounts:read": "Read accounts from FSI Insurance",
              "fsi-insurance-integrations-claims:write": "Write claims from FSI Insurance",
              "fsi-insurance-integrations-billing:read": "Read billing info from FSI Insurance",
              "fsi-insurance-integrations-claims:read": "Read claims from FSI Insurance",
              "fsi-insurance-integrations-contacts:write": "Update contact details from FSI Insurance",
              "fsi-insurance-integrations-send-docs:read": "Send document deliveries from FSI Insurance",
              "fsi-insurance-integrations-data-back:write": "Write contact event data back to FSI Insurance",
              "automated-notifications-interactions:read": "Read Automated Notifications related with interactions",
              "industries-scheduler-teams:read": "Read teams from industries-scheduler",
              "industries-scheduler-availabilities:read": "Get users availabilities by email",
              "industries-scheduler-appointment:write": "Create cancel event on specialist's calendar",
              "industries-scheduler-appointment:read": "Read appointments from industries-scheduler",
              "industries-messaging-service:write": "Write messages in industries-messaging-service",
              "interaction-custom-fields:write": "Allows to populate interaction custom fields",
              "user-session-public:end": "Terminate a user session",
              "industries-settings-public:read": "Read industries settings",
              "industries-contexts:read": "Read context values",
              "dialer-integrations-records:read": "Read dialer integrations campaign records",
              "scim": "Access SCIM-related routes",
              "hls-epic-my-chart-reset-password:write": "Trigger Epic MyChart password reset (Deprecated - use hls-patient-password-reset:write)",
              "hls-patient-password-reset:write": "Trigger patient password reset for healthcare portal",
              "locations-directory-bulk-operation:write": "Write locations directory data",
              "locations-directory-batch-operation:write": "Apply a batch of locations directory create/update/delete operations",
              "hls-patient-location:read": "Read loction patient data",
              "hls-patient-practice:read": "Read healthcare & life sciences patient practices",
              "hls-guarantor:read": "Read guarantor identifiers from providers",
              "hls-guarantor-billing:read": "Read guarantor billing summary from providers",
              "hls-guarantor-password-reset:write": "Trigger guarantor password reset for healthcare portal",
              "hls-patient-billing:read": "Read patient billing details from providers",
              "hls-interaction-overrides:write": "Write healthcare & life sciences interaction-specific configuration overrides",
              "industries-workflows:read": "Read industries workflow schedules and workflows",
              "industries-workflows:write": "Create, update, start, and delete industries workflow schedules and workflows",
              "digital-messaging-adapter:write": "Write or update Digital Messaging Adapter data"
            }
          }
        }
      }
    }
  },
  "externalDocs": {
    "description": "External Documentation",
    "url": "https://api-docs.talkdeskapp.com/external_docs"
  }
}
```